#ifndef CMATHS_H
#define CMATHS_H

#include <stdint.h>
#include <math.h>

#define MAX(_a, _b) ((_a) > (_b) ? (_a) : (_b))
#define MIN(_a, _b) ((_a) < (_b) ? (_a) : (_b))

//---------------------------------------------------------------------------------------------
class CVec2
{
public:
    CVec2(int32_t px = 0, int32_t py = 0);

    CVec2 operator+(const CVec2& rhs);
    CVec2 operator-(const CVec2& rhs);
    CVec2 operator/(int32_t rhs);
    CVec2 operator/(float rhs);
    CVec2 operator*(int32_t rhs);
    CVec2 operator*(float rhs);
    CVec2 operator%(int32_t rhs);
    void operator+=(const CVec2& rhs);
    void operator-=(const CVec2& rhs);
    void operator/=(int32_t rhs);
    void operator*=(int32_t rhs);
    void operator*=(float rhs);
    bool operator==(const CVec2& rhs);
    uint32_t squaredLength();
    float    length();
    int32_t x;
    int32_t y;
};

//---------------------------------------------------------------------------------------------
class CRect
{
public:
    CRect();
    CRect(const CVec2& pTL, const CVec2& pBR);

    CVec2 tl;   // top/left
    CVec2 br;   // bottom/right
};

#endif // CMATHS_H
