#ifndef SCRIPTS_H
#define SCRIPTS_H

#include <vector>
#include <string>
#include "../common/sources/Map.h"

class CScripts
{
public:
    CScripts();

    void execute(std::string fileName);

private:
    enum ETargetTypes
    {
        eTargetType_Tile = 0,
        eTargetType_Wall
    };

    EWallSide getWallSide(std::string word);
    void executeLine(std::vector<std::string>& words);
    void executeTarget(std::vector<std::string>& words);
    void executeSetBool(std::vector<std::string>& words);
    void executeSwitchBool(std::vector<std::string>& words);
    void executeSetType(std::vector<std::string>& words);
    void executeSetEnum(std::vector<std::string>& words);
    void executeAddObject(std::vector<std::string>& words);
    void executeIf(std::vector<std::string>& words);
    void executeSetString(std::vector<std::string>& words);

    ETargetTypes    mTargetType;
    void*       mTarget;
    CVec2       mTargetPos;
    EWallSide   mTargetSide;
    bool        lastIf;
};

extern CScripts    scripts;

#endif // SCRIPTS_H
