#include "timer.h"
#include "interface.h"

//---------------------------------------------------------------------------------------------
CTimer::CTimer()
{
    mTime = 0;
}

//---------------------------------------------------------------------------------------------
void CTimer::set(int time, bool followGameTime)
{
    mTime = time;
    mFollowGameTime = followGameTime;
}

//---------------------------------------------------------------------------------------------
int CTimer::get()
{
    return mTime;
}

//---------------------------------------------------------------------------------------------
int CTimer::getGameTimeFactor()
{
    if (interface.isGamePaused() == true)
        return 0;
    else if (interface.isSleeping() == true)
        return 4;

    return 1;
}

//---------------------------------------------------------------------------------------------
bool CTimer::update()
{
    int speed = 1;

    if (mTime != 0)
    {
        if (mFollowGameTime)
            speed = getGameTimeFactor();

        mTime -= speed;

        if (mTime <= 0)
        {
            mTime = 0;
            return true;
        }
    }
    return false;
}

//---------------------------------------------------------------------------------------------
bool CTimer::isRunning()
{
    return (mTime != 0);
}

//---------------------------------------------------------------------------------------------
void CTimer::save(FILE *handle)
{
    fwrite(&mTime, sizeof(mTime), 1, handle);
    uint8_t follow = mFollowGameTime;
    fwrite(&follow, sizeof(follow), 1, handle);
}

//---------------------------------------------------------------------------------------------
void CTimer::load(FILE *handle)
{
    fread(&mTime, sizeof(mTime), 1, handle);
    uint8_t follow;
    fread(&follow, sizeof(follow), 1, handle);
    mFollowGameTime = (bool)follow;
}
